Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## Class ShapeComponent

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  ShapeComponent

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable, RegionInterface

    public class ShapeComponent

extends JComponent
implements RegionInterface

Class ShapeCanvas: holds shapes in a custom drawn area and handles a region selection Copyright Georgia Institute of Technology 2007

Author:
  Barb Ericson ericson@cc.gatech.edu
See Also:
  Serialized Form

Nested Class Summary
`(package private) class` | `ShapeComponent.MyMouseAdapter` An inner class for handling the mouse listener interface
`(package private) class` | `ShapeComponent.MyMouseMotionAdapter` Inner class for handling the mouse motion listener

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`ShapeComponent()` A constructor that uses the default size
`ShapeComponent(BufferedImage image)` A constructor that takes a buffered image for the background
`ShapeComponent(int width, int height)` A constructor that takes the width and height

Method Summary
`void` | `add(AbstractShape shape)` Method to add a shape to the shape vector
`void` | `clearShapes()` Clear all shapes out of the shape vector
`static void` | `main(String[] argv)`
`void` | `paintComponent(Graphics g)` Method to paint the shape canvas and all objects in it
`void` | `remove(int index)` Method to remove a shape given the index
`void` | `remove(Shape shape)` Method to remove a shape from the shape vector
`void` | `setBackgroundImage(BufferedImage image)` Method to set the background image to select the region from
`void` | `setShape(String shapeType)` Set the type of the shape that will be created when the user clicks in the shape canvas.
`void` | `setVideoCapture(VideoCapturer handler)`
`void` | `update(Graphics g)` Update normally clears the background and calls paint override it here to just call paint

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, updateUI`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ShapeComponent

    public ShapeComponent()

  A constructor that uses the default size

### ShapeComponent

    public ShapeComponent(int width,
                          int height)

  A constructor that takes the width and height

  Parameters:
    `width` - the width of the canvas
    `height` - the height of the canvas

### ShapeComponent

    public ShapeComponent(BufferedImage image)

  A constructor that takes a buffered image for the background

Method Detail

### setVideoCapture

    public void setVideoCapture(VideoCapturer handler)

### setBackgroundImage

    public void setBackgroundImage(BufferedImage image)

  Description copied from interface: `RegionInterface`
  Method to set the background image to select the region from

  Specified by:
    `setBackgroundImage` in interface `RegionInterface`
  Parameters:
    `image` - the image to use

### add

    public void add(AbstractShape shape)

  Method to add a shape to the shape vector

  Parameters:
    `shape` - the shape to add

### remove

    public void remove(Shape shape)

  Method to remove a shape from the shape vector

  Parameters:
    `shape` - the shape to remove

### remove

    public void remove(int index)

  Method to remove a shape given the index

  Overrides:
    `remove` in class `Container`
  Parameters:
    `index` - the index of the shape in the shape vector that you wish to remove

### update

    public void update(Graphics g)

  Update normally clears the background and calls paint override it here to just call paint

  Overrides:
    `update` in class `JComponent`
  Parameters:
    `g` - the graphics context on which to draw

### paintComponent

    public void paintComponent(Graphics g)

  Method to paint the shape canvas and all objects in it

  Overrides:
    `paintComponent` in class `JComponent`
  Parameters:
    `g` - the graphic context on which to paint

### setShape

    public void setShape(String shapeType)

  Set the type of the shape that will be created when the user clicks in the shape canvas.

  Parameters:
    `shapeType` - the name of the shape

### clearShapes

    public void clearShapes()

  Clear all shapes out of the shape vector

  Specified by:
    `clearShapes` in interface `RegionInterface`

### main

    public static void main(String[] argv)

Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD